# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           scalacheck
Version:        1.8
Release:        3%{?dist}
Epoch:          0
Summary:        ScalaCheck Test Framework
License:        BSD
Group:          Development/Java
URL:            http://code.google.com/p/scalacheck/
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch
Source0:        scalacheck-1.8.tgz
# git clone git://github.com/rickynils/scalacheck.git
# cd scalacheck/
# git-tag -l
# mkdir ../scalacheck-1.8
# git archive 1.8 | tar -x -C ../scalacheck-1.8/
# cd ..
# tar czf scalacheck-1.8.tgz scalacheck-1.8/

Source1:        test-interface-0.5.jar
Source2:        http://repo1.maven.org/maven2/org/scala-tools/testing/scalacheck/1.6/scalacheck-1.6.pom
Patch0:         scalacheck-build.patch

BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  scala28 >= 0:2.8.1

Requires:  java >= 0:1.6.0
Requires:  scala28 >= 0:2.8.1

%description
ScalaCheck is a powerful tool for automatic unit testing of
Scala and Java programs. It features automatic test case 
generation and minimization of failing test cases. ScalaCheck
started out as a Scala port of the Haskell library QuickCheck,
and has since evolved and been extended with features not
found in Haskell QuickCheck.

%package scaladoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description scaladoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -q 
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
ln -sf $(build-classpath scala28/scala28-compiler) tools/scala-compiler.jar
ln -sf $(build-classpath scala28/scala28-library) tools/scala-library.jar
cp %{SOURCE1} tools
%patch0 -b .sav0

%build
export CLASSPATH=
%{ant} jar doc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -m 0644 target/scalacheck-%{version}-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}
for jar in *-%{version}*.jar; do ln -sf ${jar} `echo ${jar} | sed "s|-%{version}||g"`;done)

# pom
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms/
install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.scala-tools.testing %{name} %{version} JPP %{name}

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/doc/main/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_docdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/*.jar
%dir %{_docdir}/%{name}-%{version}
%{_docdir}/%{name}-%{version}/LICENSE
%dir %{_docdir}/%{name}
%{_datadir}/maven2/poms/*.pom
%{_mavendepmapfragdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/*

%changelog
* Tue Feb 05 2013 Ralph Apel <r.apel@r-apel.de> 0:1.8-3
- Prevent xzpayload problem

* Wed Jan 16 2013 Ralph Apel <r.apel@r-apel.de> 0:1.8-2
- add poms and depmap frags

* Fri Nov 04 2011 Ralph Apel <r.apel@r-apel.de> 0:1.8-1
- first release

